﻿/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Collections.Generic;
using System.Threading;
using System.Windows.Forms;

namespace RecTestSched
{
    internal class SchedulerMain : IDisposable 
    {
        //!
        static private SchedulerMain myScheduler = null;
        //!
        private System.Threading.Timer myTimer;
        //!
        private const int TIMER_SCH_UPDATE = 5 * 1000;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public SchedulerMain GetInstance()
        {
            if (myScheduler == null)
            {
                myScheduler = new SchedulerMain();
            }
            return myScheduler;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void DelInstance()
        {
            if (myScheduler != null)
            {
                myScheduler.Dispose();
                myScheduler = null;
            }
        }
 
        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void OnExit()
        {
            if (myScheduler != null)
            {
                myScheduler.Release();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public SchedulerMain()
        {
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        ~SchedulerMain()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public void Dispose()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void Initialize()
        {
            TimerCallback timerCallBack = new System.Threading.TimerCallback(TimerProc);
            myTimer = new System.Threading.Timer(timerCallBack, null, TIMER_SCH_UPDATE, TIMER_SCH_UPDATE);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
            try
            {
                if (myTimer != null)
                {
                    General.TimerPause(myTimer);
                    myTimer.Dispose();
                    myTimer = null;
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void TimerChange()
        {
            try
            {
                if (myTimer != null)
                {
                    myTimer.Change(TIMER_SCH_UPDATE, TIMER_SCH_UPDATE);
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void TimerProc(object param)
        {
            General.TimerPause(myTimer);
            ScheduleForm.GetInstance().OnUpdateRecord();
            TimerChange();
        }
    }
}
