/* ========================================================================== */
/*!
 */
/* ========================================================================== */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.IO;
using System.Xml;
using System.Windows.Forms;

namespace RecTestSched
{
    partial class ScheduleForm
    {
        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool LoadingConfig()
        {
            if (System.IO.File.Exists(Path.Combine(myAppPath, @"RecTestConfig.xml")))
            {
                if (!InportConfig())
                {
                    string msg_text = "`t@C̓ǂݍ݂Ɏs܂B"
                                    + System.Environment.NewLine
                                    + "KݒĂI"
                                    ;
                    MessageBox.Show(msg_text
                                   , "RecTest Scheduler"
                                   , MessageBoxButtons.OK
                                   , MessageBoxIcon.Exclamation
                                   , MessageBoxDefaultButton.Button1
                                   );
                    return false;
                }
                else
                {
                    UpdateChannel();
                    if (!InportSchedule())
                    {
                        string msg_text = "XPW[̓ǂݍ݂Ɏs܂B"
                                        + System.Environment.NewLine
                                        + "Ko^ĂI"
                                        ;
                        MessageBox.Show(msg_text
                                       , "RecTest Scheduler"
                                       , MessageBoxButtons.OK
                                       , MessageBoxIcon.Exclamation
                                       , MessageBoxDefaultButton.Button1
                                       );
                        return false;
                    }
                    BackupConfig();
                    BackupSchedule();
                }
            }
            else
            {
                string msg_text = "RecTest Scheduler ̒`t@C܂łB"
                                + System.Environment.NewLine
                                + "ftHg̐ݒŋNĂ܂B"
                                + System.Environment.NewLine
                                + "KݒsĂI"
                                ;
                MessageBox.Show( msg_text
                               , "RecTest Scheduler"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void BackupSchedule()
        {
            try
            {
                System.IO.File.Copy(Path.Combine(myAppPath, @"RecTestSchedule.xml"), Path.Combine(myAppPath, @"RecTestSchedule.xml.bak"), true);
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void BackupConfig()
        {
            try
            {
                System.IO.File.Copy(Path.Combine(myAppPath, @"RecTestConfig.xml"), Path.Combine(myAppPath, @"RecTestConfig.xml.bak"), true);
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void RegistFileErrorMessage(string _path)
        {
            string msg_text = "t@C܂"
                            + System.Environment.NewLine
                            + System.Environment.NewLine
                            + _path
                            ;
            MessageBox.Show( msg_text
                           , "o^s"
                           , MessageBoxButtons.OK
                           , MessageBoxIcon.Error
                           , MessageBoxDefaultButton.Button1
                           );
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool CheckRecPath(string _path)
        {
            if (_path == "" || !System.IO.File.Exists(_path))
            {
                string msg_text = "^st@C܂B"
                                + System.Environment.NewLine
                                + "Ko^ĉB"
                                ;
                MessageBox.Show( msg_text
                               , "^st@C"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Error
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool CheckDriverPath(string _path)
        {
            if (_path == "" || !System.IO.File.Exists(_path))
            {
                string msg_text = "hCot@Co^Ă܂B"
                                + System.Environment.NewLine
                                + "ɃhCoւ̃pXݒ肵ĂB"
                                ;
                MessageBox.Show(msg_text
                               , "o^s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Error
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ExportConfig()
        {
            if (General.myExceptionExit) { return; }
            if (textBoxRecPath.Text == "") { return; }
            if (dataGridViewDriver.Rows.Count < 1) { return; }
            try
            {
                using (XmlTextWriter xmlWriter = new XmlTextWriter(Path.Combine(myAppPath, @"RecTestConfig.xml"), System.Text.Encoding.UTF8))
                {
                    xmlWriter.Formatting = System.Xml.Formatting.Indented;
                    xmlWriter.WriteStartDocument(true);
                    xmlWriter.WriteStartElement("Config");
                    {
                        ExportConfigWrite(xmlWriter);
                    }
                    xmlWriter.WriteEndElement();
                    xmlWriter.WriteEndDocument();
                    xmlWriter.Close();
                }
            }
            catch (Exception exp)
            {
                General.LogOut(0, "ݒt@C(RecTestConfig.xml)̏oɎs܂I");
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private string BoolToString(bool _be)
        {
            if (_be)
            {
                return "True";
            }
            return "False";
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ExportConfigWrite(XmlTextWriter _xml)
        {
            _xml.WriteStartElement("RecPath");
            {
                _xml.WriteElementString("Entry", textBoxRecPath.Text);
                _xml.WriteElementString("Priority", comboBoxPriority.SelectedIndex.ToString());
            }
            _xml.WriteEndElement();

            _xml.WriteStartElement("Options");
            {
                _xml.WriteElementString("RecSafe", BoolToString(checkBoxRec.Checked));
                _xml.WriteElementString("Logger", BoolToString(checkBoxLog.Checked));
            }
            _xml.WriteEndElement();

            if (checkBoxTimeAdd.Checked)
            {
                int start = General.ToInt32(textBoxAddStart.Text);
                int length = General.ToInt32(textBoxAddLength.Text);
                if (start != 0 || length != 0)
                {
                    _xml.WriteStartElement("TimeAdd");
                    {
                        _xml.WriteElementString("Start", start.ToString());
                        _xml.WriteElementString("Length", length.ToString());
                    }
                    _xml.WriteEndElement();
                }
            }

            if (checkBoxShiftTime.Checked)
            {
                int shift = General.ToInt32(textBoxShiftTime.Text);
                if (shift != 0)
                {
                    _xml.WriteStartElement("TimeShift");
                    {
                        _xml.WriteElementString("Entry", shift.ToString());
                    }
                    _xml.WriteEndElement();
                }
            }

            if (checkBoxTwitter.Checked)
            {
                if (textBoxTwiName.Text != ""
                    &&
                    textBoxTwiPass.Text != ""
                   )
                {
                    _xml.WriteStartElement("Twitter");
                    {
                        _xml.WriteElementString("User", textBoxTwiName.Text);
                        _xml.WriteElementString("Pass", textBoxTwiPass.Text);
                    }
                    _xml.WriteEndElement();
                }
            }

            _xml.WriteStartElement("DriverList");
            {
                foreach (DataGridViewRow drvRows in dataGridViewDriver.Rows)
                {
                    _xml.WriteStartElement("Entry");
                    _xml.WriteElementString("Name", General.ToString(drvRows.Cells, ColumnName));
                    _xml.WriteElementString("Driver", General.ToString(drvRows.Cells, ColumnDriver));
                    _xml.WriteElementString("Channel", General.ToString(drvRows.Cells, ColumnChannel));
                    _xml.WriteElementString("Argument", General.ToString(drvRows.Cells, ColumnArgument));
                    _xml.WriteElementString("Process", General.ToString(drvRows.Cells, ColumnProcess));
                    _xml.WriteElementString("Ahead", General.ToString(drvRows.Cells, ColumnAhead));
                    _xml.WriteEndElement();
                }
            }
            _xml.WriteEndElement();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ExportSchedule()
        {
            if (General.myExceptionExit) { return; }
            ScheduleRowsFlash();
            ScheduleRowsSort();
            try
            {
                using (XmlTextWriter xmlWriter = new XmlTextWriter(Path.Combine(myAppPath, @"RecTestSchedule.xml"), System.Text.Encoding.UTF8))
                {
                    xmlWriter.Formatting = System.Xml.Formatting.Indented;
                    xmlWriter.WriteStartDocument(true);
                    xmlWriter.WriteStartElement("Schedule");
                    {
                        ExportScheduleWrite(xmlWriter);
                    }
                    xmlWriter.WriteEndElement();
                    xmlWriter.WriteEndDocument();
                    xmlWriter.Close();
                }
            }
            catch (Exception exp)
            {
                General.LogOut(0, "XPW[(RecTestSchedule.xml)̏oɎs܂I");
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ExportScheduleWrite(XmlTextWriter _xml)
        {
            _xml.WriteStartElement("Count");
            {
                _xml.WriteElementString("Entry", dataGridViewSchedule.Rows.Count.ToString());
            }
            _xml.WriteEndElement();

            if (dataGridViewSchedule.Rows.Count > 0)
            {
                _xml.WriteStartElement("ProgramList");
                {
                    foreach (DataGridViewRow schRows in dataGridViewSchedule.Rows)
                    {
                        _xml.WriteStartElement("Entry");
                        {
                            _xml.WriteElementString("UID", General.ToString(schRows.Cells, ColumnUID));
                            _xml.WriteElementString("Title", General.ToString(schRows.Cells, ColumnTitle));
                            _xml.WriteElementString("Station", General.ToString(schRows.Cells, ColumnRecChannel));
                            _xml.WriteElementString("DateTime", General.ToString(schRows.Cells, ColumnDate));
                            _xml.WriteElementString("Length", General.ToString(schRows.Cells, ColumnLength));
                            _xml.WriteElementString("Descript", General.ToString(schRows.Cells, ColumnDescript));
                            //_xml.WriteElementString("Status", General.ToString(schRows.Cells, ColumnStatus));
                        }
                        _xml.WriteEndElement();
                    }
                }
                _xml.WriteEndElement();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfig()
        {
            bool beOK = false;
            try
            {
                using (XmlReader xmlReader = new XmlTextReader(Path.Combine(myAppPath, @"RecTestConfig.xml")))
                {
                    ClearDriver();
                    beOK = true;
                    while (xmlReader.Read())
                    {
                        switch (xmlReader.NodeType)
                        {
                            case XmlNodeType.Element:
                                if (!InportConfigElement(xmlReader))
                                {
                                    beOK = false;
                                }
                                break;
                        }
                    }
                    xmlReader.Close();
                }
            }
            catch (Exception exp)
            {
                ClearDriver();
                beOK = false;
                General.LogOut(0, "ݒt@C(RecTestConfig.xml)̓ǂݏoɎs܂I");
                General.OutputString(exp.StackTrace, exp.Message);
            }
            CheckAddTimeText();
            CheckPriorityText();
            return beOK;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigElement(XmlReader _xml)
        {
            switch (_xml.Name)
            {
                case "RecLoop": return InportConfigRecLoop(_xml);
                case "Options": return InportConfigOptions(_xml);
                case "TimeAdd": return InportConfigAddTime(_xml);
                case "TimeShift": return InportConfigShiftTime(_xml);
                case "Twitter": return InportConfigTwitter(_xml);
                case "RecPath": return InportConfigRecPath(_xml);
                case "DriverList": return InportConfigDriver(_xml);
            }
            // mȂ^O͖
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigRecLoop(XmlReader _xml)
        {
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        if (_xml.LocalName.Equals("Entry"))
                        {
                            if (_xml.ReadString() == "True")
                            {
                                checkBoxRec.Checked = true;
                            }
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("RecLoop"))
                        {
                            return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigOptions(XmlReader _xml)
        {
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch(_xml.LocalName)
                        {
                            case "RecSafe":
                                if (_xml.ReadString() == "True")
                                {
                                    checkBoxRec.Checked = true;
                                }
                                break;

                            case "Logger":
                                if (_xml.ReadString() == "True")
                                {
                                    checkBoxLog.Checked = true;
                                }
                                break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("Options"))
                        {
                            return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigAddTime(XmlReader _xml)
        {
            int start = 0;
            int length = 0;
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch (_xml.LocalName)
                        {
                            case "Start": start = General.ToInt32(_xml.ReadString()); break;
                            case "Length": length = General.ToInt32(_xml.ReadString()); break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("TimeAdd"))
                        {
                            if (start == 0 && length == 0)
                            {
                            }
                            else
                            {
                                textBoxAddStart.Text = start.ToString();
                                textBoxAddLength.Text = length.ToString();
                                checkBoxTimeAdd.Checked = true;
                                TimeAddUpdate();
                            }
                            return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigShiftTime(XmlReader _xml)
        {
            int shift = 0;
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch (_xml.LocalName)
                        {
                            case "Entry": shift = General.ToInt32(_xml.ReadString()); break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("TimeShift"))
                        {
                            if (shift != 0)
                            {
                                textBoxShiftTime.Text = shift.ToString();
                                checkBoxShiftTime.Checked = true;
                                ShiftTimeUpdate();
                            }
                            return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigTwitter(XmlReader _xml)
        {
            string user = "";
            string pass = "";
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch (_xml.LocalName)
                        {
                            case "User": user = _xml.ReadString(); break;
                            case "Pass": pass = _xml.ReadString(); break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("Twitter"))
                        {
                            if (user != "" && pass != "")
                            {
                                textBoxTwiName.Text = user;
                                textBoxTwiPass.Text = pass;
                                checkBoxTwitter.Checked = true;
                                TwitterCheckUpdate();
                            }
                            return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigRecPath(XmlReader _xml)
        {
            string strPath = "";
            int intSel = 1;
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        if (_xml.LocalName.Equals("Entry"))
                        {
                            strPath = _xml.ReadString();
                        }
                        if (_xml.LocalName.Equals("Priority"))
                        {
                            intSel = General.ToInt32(_xml.ReadString());
                            if (intSel < 0) { intSel = 1; }
                            if (intSel > comboBoxPriority.Items.Count) { intSel = 1; }                           
                        }
                        break;

                    case XmlNodeType.EndElement:
                        if (_xml.LocalName.Equals("RecPath"))
                        {
                            if (!System.IO.File.Exists(strPath))
                            {
                                MessageBox.Show( "st@C܂I"
                                               , "s"
                                               , MessageBoxButtons.OK
                                               , MessageBoxIcon.Error
                                               , MessageBoxDefaultButton.Button1
                                               );
                            }
                            else
                            {
                                textBoxRecPath.Text = strPath;
                                comboBoxPriority.SelectedIndex = intSel;
                                return true;
                            }
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportConfigDriver(XmlReader _xml)
        {
            string strName = "";
            string strDriver = "";
            string strChannel = "";
            string strArgument = "";
            string strProcess = "";
            string strAhead = "";
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch (_xml.LocalName)
                        {
                            case "Name": strName = _xml.ReadString(); break;
                            case "Driver": strDriver = _xml.ReadString(); break;
                            case "Channel": strChannel = _xml.ReadString(); break;
                            case "Argument": strArgument = _xml.ReadString(); break;
                            case "Process": strProcess = _xml.ReadString(); break;
                            case "Ahead": strAhead = _xml.ReadString(); break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        switch (_xml.LocalName)
                        {
                            case "Entry":
                                bool beCheck = true;
                                if (!System.IO.File.Exists(strDriver))
                                {
                                    beCheck = false;
                                    string msg_text = "hCo܂I"
                                                    + System.Environment.NewLine
                                                    + System.Environment.NewLine
                                                    + strName
                                                    + System.Environment.NewLine
                                                    + strDriver
                                                    + System.Environment.NewLine
                                                    ;
                                    MessageBox.Show(msg_text
                                                   , "s"
                                                   , MessageBoxButtons.OK
                                                   , MessageBoxIcon.Error
                                                   , MessageBoxDefaultButton.Button1
                                                   );
                                }
                                if (!System.IO.File.Exists(strChannel))
                                {
                                    beCheck = false;
                                    string msg_text = "`lt@C܂I"
                                                    + System.Environment.NewLine
                                                    + System.Environment.NewLine
                                                    + strName
                                                    + System.Environment.NewLine
                                                    + strChannel
                                                    + System.Environment.NewLine
                                                    ;
                                    MessageBox.Show(msg_text
                                                   , "s"
                                                   , MessageBoxButtons.OK
                                                   , MessageBoxIcon.Error
                                                   , MessageBoxDefaultButton.Button1
                                                   );
                                }
                                int intProc = General.ToInt32(strProcess);
                                if (intProc < 1)
                                {
                                    beCheck = false;
                                    string msg_text = "^搔̎w肪܂I"
                                                    + System.Environment.NewLine
                                                    + System.Environment.NewLine
                                                    + strName
                                                    + System.Environment.NewLine
                                                    + strProcess
                                                    + System.Environment.NewLine
                                                    ;
                                    MessageBox.Show(msg_text
                                                   , "s"
                                                   , MessageBoxButtons.OK
                                                   , MessageBoxIcon.Error
                                                   , MessageBoxDefaultButton.Button1
                                                   );
                                }
                                if (!General.IsInt32(strAhead))
                                {
                                    strAhead = "10";
                                }
                                if (beCheck)
                                {
                                    DriverRowsAdd(strName
                                                 , strDriver
                                                 , strChannel
                                                 , strArgument
                                                 , strProcess
                                                 , strAhead
                                                 );
                                }
                                strName = "";
                                strDriver = "";
                                strChannel = "";
                                strArgument = "";
                                strAhead = "";
                                break;

                            case "DriverList":
                                return (dataGridViewDriver.Rows.Count > 0);
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportSchedule()
        {
            bool beOK = false;
            try
            {
                using (XmlReader xmlReader = new XmlTextReader(Path.Combine(myAppPath, @"RecTestSchedule.xml")))
                {
                    ClearSchedule();
                    beOK = true;
                    while (xmlReader.Read())
                    {
                        switch (xmlReader.NodeType)
                        {
                            case XmlNodeType.Element:
                                if (!InportScheduleElement(xmlReader))
                                {
                                    beOK = false;
                                }
                                break;
                        }
                    }
                    xmlReader.Close();
                }
            }
            catch (Exception exp)
            {
                ClearSchedule();
                beOK = false;
                General.LogOut(0, "XPW[(RecTestSchedule.xml)̓ǂݏoɎs܂I");
                General.OutputString(exp.StackTrace, exp.Message);
            }
            ScheduleRowsSort();
            return beOK;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportScheduleElement(XmlReader _xml)
        {
            switch (_xml.Name)
            {
                case "ProgramList": return InportScheduleProgram(_xml);
            }
            // mȂ^O͖
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool InportScheduleProgram(XmlReader _xml)
        {
            string strUID = "";
            string strTitle = "";
            string strStation = "";
            string strDateTime = "";
            string strLength = "";
            string strDescript = "";
            while (_xml.Read())
            {
                switch (_xml.NodeType)
                {
                    case XmlNodeType.Element:
                        switch (_xml.LocalName)
                        {
                            case "UID": strUID = _xml.ReadString(); break;
                            case "Title": strTitle = _xml.ReadString(); break;
                            case "Station": strStation = _xml.ReadString(); break;
                            case "DateTime": strDateTime = _xml.ReadString(); break;
                            case "Length": strLength = _xml.ReadString(); break;
                            case "Descript": strDescript = _xml.ReadString(); break;
                        }
                        break;

                    case XmlNodeType.EndElement:
                        switch (_xml.LocalName)
                        {
                            case "Entry":
                                DateTime dateTime = General.ToDateTime(strDateTime);
                                OnUpdateSchedule( strTitle
                                                , strUID
                                                , strStation
                                                , dateTime
                                                , General.ToInt32(strLength)
                                                , strDescript
                                                , ""
                                                , false
                                                );
                                strUID = "";
                                strTitle = "";
                                strStation = "";
                                strDateTime = "";
                                strLength = "";
                                strDescript = "";
                                break;

                            case "ProgramList":
                                return true;
                        }
                        break;
                }
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool ImportChannel(string _path, string _name)
        {
            bool beResult = false;
            try
            {
                using (System.IO.StreamReader fpRead = new System.IO.StreamReader(_path, System.Text.Encoding.GetEncoding(932)))
                {
                    while (fpRead.Peek() > -1)
                    {
                        string strLine = fpRead.ReadLine();
                        if (strLine.Substring(0, 1) == ";") { continue; }
                        string[] strArray = strLine.Split(',');
                        if (strArray[0] == "") { continue; }
                        if (strArray[1] == "") { continue; }
                        if (strArray[3] == "") { continue; }
                        if (strArray[5] == "") { continue; }
                        ChannelRowsAdd( _name
                                      , strArray[0]
                                      , strArray[1]
                                      , strArray[3]
                                      , strArray[5]
                                      );
                    }
                    fpRead.Close();
                }
                beResult = true;
            }
            catch (Exception exp)
            {
                beResult = false;
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return beResult;
        }

    }
}