/* ========================================================================== */
/*!
 */
/* ========================================================================== */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

namespace RecTestSched
{
    partial class ScheduleForm
    {

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void OnExit()
        {
            if (mySchForm != null)
            {
                try
                {
                    mySchForm.notifyIconRec.Visible = false;
                    mySchForm.notifyIconRec.Dispose();
                }
                catch (Exception exp)
                {
                    General.OutputString(exp.StackTrace, exp.Message);
                }
                mySchForm.Release();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUpdateChannel(List<string> _list)
        {
            int insIndex = 0;
            foreach (DataGridViewRow chRows in dataGridViewChannel.Rows)
            {
                bool beAdd = true;
                string strChName = General.ToString(chRows.Cells, ColumnChName);
                string strChDrv = "{" + General.ToString(chRows.Cells, ColumnIndex) + "} "
                                + strChName;
                foreach (string strCh in _list)
                {
                    if (strCh == strChName)
                    {
                        _list.Add(strChDrv);
                        beAdd = false;
                        break;
                    }
                }
                if (beAdd)
                {
                    _list.Add(strChDrv);
                    _list.Insert(insIndex, strChName);
                    ++insIndex;
                }
                /*
                foreach (string strCh in _list)
                {
                    if (strCh == strChName)
                    {
                        _list.Insert(insIndex + 1, strChDrv);
                        beAdd = false;
                        break;
                    }
                    ++insIndex;
                }
                if (beAdd)
                {
                    _list.Add(strChName);
                    _list.Add(strChDrv);
                }
                */
            }
            comboBoxCh.Items.Clear();
            foreach (string strCh in _list)
            {
                comboBoxCh.Items.Add(strCh);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUpdateSchedule( string _title
                                      , string _unique
                                      , string _station
                                      , DateTime _date
                                      , int _minute
                                      , string _descript
                                      , string _status
                                      , bool _save
                                      )
        {
            foreach (DataGridViewRow scRows in dataGridViewSchedule.Rows)
            {
                if (_unique == General.ToString(scRows.Cells, ColumnUID))
                {
                    string state = General.ToString(scRows.Cells, ColumnStatus);
                    if (state != "")
                    {
                        string log_text = _title
                                        + "XV܂Ałɓ삵Ă邽ߕύXł܂ł "
                                        + General.ToString(scRows.Cells, ColumnDate)
                                        + "(" + General.ToString(scRows.Cells, ColumnLength) + ") ->"
                                        + _date.ToString()
                                        + "(" + _minute.ToString() + ")"
                                        ;
                        General.LogOut(0, log_text);
                        return;
                    }
                    ScheduleRowsUpdate( scRows.Cells
                                      , _unique
                                      , _title
                                      , _station
                                      , _date
                                      , _minute
                                      , _descript
                                      , _status
                                      );
                    if (_save)
                    {
                        ExportSchedule();
                        General.LogOut(2, _title + "(" + _date.ToString() + ")̗\XV܂");
                    }
                    return;
                }
            }
            if (_minute > 0)
            {
                ScheduleRowsAdd(_unique
                              , _title
                              , _station
                              , _date
                              , _minute
                              , _descript
                              , _status
                              );
                if (_save)
                {
                    ExportSchedule();
                    General.LogOut(2, _title + "(" + _date.ToString() + ")\񂵂܂");
                }
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUnloadSchedule( string _title
                                      , string _unique
                                      )
        {
            ScheduleRowsClearSel(_unique);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool OnSearchSchedule( string _title
                                      , string _unique
                                      )
        {
            foreach (DataGridViewRow scRows in dataGridViewSchedule.Rows)
            {
                if (_unique == General.ToString(scRows.Cells, ColumnUID))
                {
                    return true;
                }
            }
            General.LogOut(2, _title + " (" + _unique + ") ͓o^Ă܂");
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUpdateRecording( string _uid
                                       , string _stt
                                       )
        {
            int exec = CheckProcessCount(_stt);
            foreach (DataGridViewRow scRows in dataGridViewSchedule.Rows)
            {
                if (_uid == General.ToString(scRows.Cells, ColumnUID))
                {
                    scRows.Cells[ColumnStatus.Index].Value = "^撆";
                    DateTime startDate = General.ToDateTime(scRows.Cells, ColumnDate);
                    TimeSpan spanTime = DateTime.Now - startDate;
                    int spanSec = General.ToInt32(spanTime.TotalSeconds);
                    string log_text = General.ToString(scRows.Cells, ColumnTitle)
                                    + "̘^"
                                    + _stt.ToString() + "(" + exec.ToString()
                                    + ")ŊJn܂ (\񂩂"
                                    + spanSec.ToString()
                                    + "bł)";
                    General.LogOut(0, log_text);
                    break;
                }
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUpdateRecorded(string _uid, string _stt)
        {
            int exec = SubProcessCount(_stt);
            foreach (DataGridViewRow scRows in dataGridViewSchedule.Rows)
            {
                if (_uid == General.ToString(scRows.Cells, ColumnUID))
                {
                    scRows.Cells[ColumnStatus.Index].Value = "^抮";
                    string log_text = General.ToString(scRows.Cells, ColumnTitle)
                                    + "̘^悪I܂ ("
                                    + exec.ToString() + ")"
                                    ;
                    General.LogOut(2, log_text);
                    break;
                }
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void OnUpdateRecord()
        {
            ScheduleRowsCrawl();
            int lagSec = 31 - myAddStart - myShiftTime * 3;
            DateTime recTime = DateTime.Now.AddSeconds(lagSec);
            foreach (DataGridViewRow scRows in dataGridViewSchedule.Rows)
            {
                if (General.ToString(scRows.Cells, ColumnStatus) != "")
                {
                    continue;
                }
                if (General.ToDateTime(scRows.Cells, ColumnDate) < recTime)
                {
                    int lenMinute = CheckRecording(scRows.Cells);
                    if (lenMinute < 1) { continue; }
                    RequestTwitterSchedule(scRows.Cells);
                    bool beRec = false;
                    string strChName = General.ToString(scRows.Cells, ColumnRecChannel);
                    if (strChName[0] == '{')
                    {
                        beRec = SearchFromDriver(scRows.Cells
                                                , strChName.Split('}')[0].Substring(1)
                                                , strChName.Split('}')[1].Substring(1)
                                                , lenMinute
                                                );
                    }
                    else
                    {
                        beRec = SearchFromChannel(scRows.Cells
                                                 , strChName
                                                 , lenMinute
                                                 );
                    }
                }
            }
        }

    }
}