/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;
using System.Collections;
using System.Text.RegularExpressions;
using Microsoft.VisualBasic;

namespace RecTestSched
{
    partial class ScheduleForm
    {
        //!
        private Hashtable myProcess = new Hashtable();
        //!
        private int myAddStart = 0;
        //!
        private int myAddLength = 0;
        //!
        private int myShiftTime = 0;
        //!
        private string myPriority = "Normal";
        //!
        private const Int32 LOG_IDF_LAGGED = 0x00000001;
        //!
        private const Int32 LOG_IDF_DRIVER = 0x00000002;
        //!
        private const Int32 LOG_IDF_TWIREC = 0x00000010;
        //!
        private const Int32 LOG_IDF_TWILAG = 0x00000020;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private string DialogFileSelect( string _filter
                                       , string _title
                                       )
        {
            openFileDialogCommon.Filter = _filter;
            openFileDialogCommon.FilterIndex = 0;
            openFileDialogCommon.FileName = "";
            openFileDialogCommon.Multiselect = false;
            openFileDialogCommon.ValidateNames = true;
            openFileDialogCommon.DereferenceLinks = true;
            openFileDialogCommon.CheckPathExists = true;
            openFileDialogCommon.CheckFileExists = true;
            openFileDialogCommon.Title = _title;
            try
            {
                openFileDialogCommon.ShowDialog();
                return openFileDialogCommon.FileName;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return "";
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void NewScheduleAdd()
        {
            if (CheckScheduleText())
            {
                OnUpdateSchedule( textBoxTitle.Text
                                , textBoxUID.Text
                                , comboBoxCh.Text
                                , dateTimeSchedule.Value
                                , General.ToInt32(textBoxLength.Text)
                                , textBoxTitle.Text
                                , ""
                                , true
                                );
                DefaultScheduleBox();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void DelScheduleUpdate(int _select)
        {
            DataGridViewCellCollection trgCells = dataGridViewSchedule.Rows[_select].Cells;
            string msg_text = "^\폜܂B"
                            + System.Environment.NewLine
                            + "낵łH"
                            + System.Environment.NewLine
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnUID)
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnTitle)
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnDate)
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnLength) + ""
                            ;
            DialogResult result = MessageBox.Show( msg_text
                                                 , "폜܂"
                                                 , MessageBoxButtons.OKCancel
                                                 , MessageBoxIcon.Question
                                                 , MessageBoxDefaultButton.Button2
                                                 );
            if (result == DialogResult.OK)
            {
                ScheduleRowsDel(_select);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void NewDriverAdd()
        {
            if (CheckDriverText(-1))
            {
                DriverRowsAdd(textBoxDrvName.Text
                            , textBoxDrvPath.Text
                            , textBoxChPath.Text
                            , textBoxArg.Text
                            , textBoxRecCount.Text
                            , textBoxAhead.Text
                            );
                DefaultDriverBox();
                UpdateChannel();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void NewDriverUpdate(int _select)
        {
            if (CheckDriverText(_select))
            {
                DriverRowsUpdate(dataGridViewDriver.Rows[_select].Cells
                                , textBoxDrvName.Text
                                , textBoxDrvPath.Text
                                , textBoxChPath.Text
                                , textBoxArg.Text
                                , textBoxRecCount.Text
                                , textBoxAhead.Text
                                );
                DefaultDriverBox();
                UpdateChannel();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void DelDriverUpdate(int _select)
        {
            DataGridViewCellCollection trgCells = dataGridViewDriver.Rows[_select].Cells;
            string msg_text = "LhCo폜܂B"
                            + System.Environment.NewLine
                            + "낵łH"
                            + System.Environment.NewLine
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnName)
                            + System.Environment.NewLine
                            + General.ToString(trgCells, ColumnDriver)
                            ;
            DialogResult msgResult = MessageBox.Show(msg_text
                                                    , "폜܂"
                                                    , MessageBoxButtons.OKCancel
                                                    , MessageBoxIcon.Question
                                                    , MessageBoxDefaultButton.Button2
                                                    );
            if (msgResult == DialogResult.OK)
            {
                DriverRowsDel(_select);
                DefaultDriverBox();
                UpdateChannel();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void UpdateChannel()
        {
            dataGridViewChannel.Rows.Clear();
            foreach (DataGridViewRow drvRow in dataGridViewDriver.Rows)
            {
                bool beResult = false;
                string strPath = General.ToString(drvRow.Cells, ColumnChannel);
                if (System.IO.File.Exists(strPath))
                {
                    beResult = ImportChannel(strPath, General.ToString(drvRow.Cells, ColumnName));
                }
                if (!beResult)
                {
                    string msg_text = "`lt@C܂I"
                                    + System.Environment.NewLine
                                    + System.Environment.NewLine
                                    + strPath
                                    ;
                    MessageBox.Show( msg_text
                                   , "s"
                                   , MessageBoxButtons.OK
                                   , MessageBoxIcon.Exclamation
                                   , MessageBoxDefaultButton.Button1
                                   );
                }
            }
            {
                List<string> result = new List<string>();
                OnUpdateChannel(result);
                result.Clear();
                result = null;
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void SelectRecExeFile()
        {
            string strFileName = DialogFileSelect("RecTest(RecTest.exe)|RecTest.exe|TVTest(TVTest.exe)|TVTest.exe|st@C(*.exe)|*.exe"
                                                 , "^st@CIĉ"
                                                 );
            if (strFileName == "") { return; }
            bool beOK = false;
            try
            {
                if (System.IO.File.Exists(strFileName))
                {
                    textBoxRecPath.Text = strFileName;
                    beOK = true;
                }
            }
            catch (Exception exp)
            {
                beOK = false;
                General.OutputString(exp.StackTrace, exp.Message);
            }
            if (!beOK)
            {
                RegistFileErrorMessage(strFileName);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void SelectDriverFile()
        {
            if (!CheckRecPath(textBoxRecPath.Text)) { return; }
            string strFileName = DialogFileSelect("hCo(*.dll)|*.dll|ׂẴt@C(*.*)|*.*"
                                                 , "hCot@CIĉ"
                                                 );
            if (strFileName == "") { return; }
            bool beOK = false;
            try
            {
                if (System.IO.File.Exists(strFileName))
                {
                    string path = Path.GetDirectoryName(strFileName);
                    string name = Path.GetFileNameWithoutExtension(strFileName);
                    textBoxDrvPath.Text = strFileName;
                    path = Path.Combine(path, name + ".ch2");
                    if (System.IO.File.Exists(path))
                    {
                        textBoxChPath.Text = path;
                        beOK = true;
                    }
                }
            }
            catch (Exception exp)
            {
                beOK = false;
                General.OutputString(exp.StackTrace, exp.Message);
            }
            if (!beOK)
            {
                RegistFileErrorMessage(strFileName);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void SelectChannelFile()
        {
            if (!CheckRecPath(textBoxRecPath.Text)) { return; }
            if (!CheckDriverPath(textBoxDrvPath.Text)) { return; }
            string strFileName = DialogFileSelect("`l(*.ch2)|*.ch2|ׂẴt@C(*.*)|*.*"
                                                 , "`l`t@CIĉ"
                                                 );
            if (strFileName == "") { return; }
            bool beOK = false;
            try
            {
                if (System.IO.File.Exists(strFileName))
                {
                    string path1 = Path.GetDirectoryName(textBoxDrvPath.Text);
                    string path2 = Path.GetDirectoryName(strFileName);
                    if (path1 != path2)
                    {
                        string msg_text = "whCoƃtH_قȂ܂B"
                                        + System.Environment.NewLine
                                        + "RecTest삵Ȃ\܂A낵łH"
                                        + System.Environment.NewLine
                                        + System.Environment.NewLine
                                        + "hCo@: " + path1
                                        + System.Environment.NewLine
                                        + "`l: " + path2
                                        ;
                        DialogResult result = MessageBox.Show(msg_text
                                                             , "tH_Ⴂ܂"
                                                             , MessageBoxButtons.OKCancel
                                                             , MessageBoxIcon.Exclamation
                                                             , MessageBoxDefaultButton.Button2
                                                             );
                        if (result == DialogResult.OK)
                        {
                            textBoxChPath.Text = strFileName;
                            beOK = true;
                        }
                    }
                    else
                    {
                        textBoxChPath.Text = strFileName;
                        beOK = true;
                    }
                }
            }
            catch (Exception exp)
            {
                beOK = false;
                General.OutputString(exp.StackTrace, exp.Message);
            }
            if (!beOK)
            {
                RegistFileErrorMessage(strFileName);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool CheckDriverText(int _select)
        {
            if (textBoxDrvName.Text == "")
            {
                MessageBox.Show( "o^LĉI"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            foreach (DataGridViewRow drvRow in dataGridViewDriver.Rows)
            {
                if (_select == drvRow.Index) { continue; }
                if (textBoxDrvName.Text == General.ToString(drvRow.Cells, ColumnName))
                {
                    string msg_text = "Oݒ肷鎖͂ł܂I"
                                    + System.Environment.NewLine
                                    + System.Environment.NewLine
                                    + textBoxDrvName.Text
                                    + " == "
                                    + General.ToString(drvRow.Cells, ColumnName)
                                    ;
                    MessageBox.Show( msg_text
                                   , "s"
                                   , MessageBoxButtons.OK
                                   , MessageBoxIcon.Exclamation
                                   , MessageBoxDefaultButton.Button1
                                   );
                    return false;
                }
            }
            if (textBoxDrvPath.Text == "")
            {
                MessageBox.Show( "hCõpXݒ肵ĉI"
                                , "s"
                                , MessageBoxButtons.OK
                                , MessageBoxIcon.Exclamation
                                , MessageBoxDefaultButton.Button1
                                );
                return false;
            }
            if (!System.IO.File.Exists(textBoxDrvPath.Text))
            {
                MessageBox.Show( "hCo܂I"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (textBoxChPath.Text == "")
            {
                MessageBox.Show( "`lt@Cݒ肵ĉI"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (!System.IO.File.Exists(textBoxChPath.Text))
            {
                MessageBox.Show( "`lt@C܂I"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (textBoxRecCount.Text == "")
            {
                MessageBox.Show( "^搔ݒ肵ĉI"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (General.ToInt32(textBoxRecCount.Text) < 1)
            {
                MessageBox.Show( "^搔słI"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (textBoxRecCount.Text == "")
            {
                MessageBox.Show( "Nx(b)ݒ肵ĉI"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool CheckScheduleText()
        {
            if (textBoxTitle.Text == "")
            {
                MessageBox.Show( "^Cg͂Ă܂B"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            if (comboBoxCh.Text == "")
            {
                MessageBox.Show( "`lݒ肳Ă܂B"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            int recLength = General.ToInt32(textBoxLength.Text);
            if (recLength < 1)
            {
                MessageBox.Show( "^掞ԂZ܂B"
                               , "s"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return false;
            }
            DateTime nowTime = DateTime.Now.AddMinutes(1);
            if (dateTimeSchedule.Value < nowTime)
            {
                string msg_text = "JnԂ\\Ԃ߂Ă܂B"
                                + System.Environment.NewLine
                                + "삵Ȃ\܂A낵łH"
                                + System.Environment.NewLine
                                + System.Environment.NewLine
                                + "o^@: " + nowTime.ToString()
                                + System.Environment.NewLine
                                + "Jn@: " + dateTimeSchedule.Value.ToString()
                                ;
                DialogResult result = MessageBox.Show( msg_text
                                                     , "s"
                                                     , MessageBoxButtons.OKCancel
                                                     , MessageBoxIcon.Exclamation
                                                     , MessageBoxDefaultButton.Button2
                                                     );

                if (result == DialogResult.Cancel)
                {
                    return false;
                }
            }
            return true;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private string ReplaceArgumentText(string _cmd
                                          , string _driver
                                          , string _chsp
                                          , string _ch
                                          , string _sid
                                          , string _minutes
                                          , string _second
                                          , string _delay
                                          , string _uid
                                          , string _title
                                          , string _did
                                          , DateTime _date
                                          )
        {
            _cmd = _cmd.Replace("{driver}", _driver);
            _cmd = _cmd.Replace("{chsp}", _chsp);
            _cmd = _cmd.Replace("{ch}", _ch);
            _cmd = _cmd.Replace("{sid}", _sid);
            _cmd = _cmd.Replace("{minutes}", _minutes);
            _cmd = _cmd.Replace("{second}", _second);
            _cmd = _cmd.Replace("{delay}", _delay);
            _cmd = _cmd.Replace("{uid}", _uid);
            _cmd = _cmd.Replace("{title}", _title);
            _cmd = _cmd.Replace("{did}", _did);
            _cmd = _cmd.Replace("{date}", _date.ToString("yyMMdd"));
            _cmd = _cmd.Replace("{time}", _date.ToString("HHmmss"));
            return _cmd;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void CheckArgumentText()
        {
            if (textBoxArg.Text == "")
            {
                MessageBox.Show("LqĂ܂I"
                               , "x"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                return;
            }
            string strCmd = ReplaceArgumentText(textBoxArg.Text
                                               , "[hCo]"
                                               , "[`[jO]"
                                               , "[R]"
                                               , "[T[rXID]"
                                               , "[()]"
                                               , "[(b)]"
                                               , "[x(b)]"
                                               , "[ʃR[h]"
                                               , "[^Cg]"
                                               , "[hCo]"
                                               , DateTime.Now
                                               );
            strCmd = strCmd.Replace(" /", System.Environment.NewLine + "/");
            MessageBox.Show(strCmd
                           , "R}h"
                           , MessageBoxButtons.OK
                           , MessageBoxIcon.Information
                           , MessageBoxDefaultButton.Button1
                           );
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int CheckRecording(DataGridViewCellCollection _cell)
        {
            int lenMinute = General.ToInt32(_cell, ColumnLength);
            DateTime startDate = General.ToDateTime(_cell, ColumnDate);
            DateTime stopDate = startDate.AddMinutes(lenMinute);
            if (stopDate < DateTime.Now)
            {
                _cell[ColumnStatus.Index].Value = "^掸s";
                string log_text = General.ToString(_cell, ColumnTitle)
                                + "̘^Ɏs܂BԌo ("
                                + startDate.ToString() + " < " + DateTime.Now.ToString()
                                + ")"
                                ;
                General.LogOut(0, log_text);
                return -1;
            }
            if (startDate < DateTime.Now)
            {
                TimeSpan spanTime = stopDate - DateTime.Now;
                lenMinute = General.ToInt32(spanTime.TotalMinutes);
                if (lenMinute < 1)
                {
                    _cell[ColumnStatus.Index].Value = "^掸s";
                    string log_text = General.ToString(_cell, ColumnTitle)
                                    + "̘^Ɏs܂BԌo ("
                                    + startDate.ToString() + " < " + DateTime.Now.ToString()
                                    + ") c" + lenMinute.ToString() + ""
                                    ;
                    General.LogOut(0, log_text);
                    return -1;
                }
                else
                {
                    Int32 uFlags = General.ToInt32(_cell, ColumnLog);
                    _cell[ColumnLog.Index].Value = uFlags | LOG_IDF_LAGGED;
                    RequestTwitterLagged(_cell);
                }
            }
            return lenMinute;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int CheckProcessCount(string _stt)
        {
            int exec = 0;
            try
            {
                if (myProcess.ContainsKey(_stt))
                {
                    exec = General.ToInt32(myProcess[_stt]);
                    if (exec < 1)
                    {
                        exec = 1;
                        myProcess[_stt] = exec;
                    }
                }
                else
                {
                    exec = 1;
                    myProcess.Add(_stt, exec);
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return exec;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int SubProcessCount(string _stt)
        {
            int exec = -1;
            try
            {
                if (myProcess.ContainsKey(_stt))
                {
                    exec = General.ToInt32(myProcess[_stt]);
                    if (exec > 0)
                    {
                        --exec;
                        myProcess[_stt] = exec;
                    }
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return exec;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int AddProcessCount(string _stt)
        {
            int exec = 0;
            try
            {
                if (myProcess.ContainsKey(_stt))
                {
                    exec = General.ToInt32(myProcess[_stt]) + 1;
                    myProcess[_stt] = exec;
                }
                else
                {
                    exec = 1;
                    myProcess.Add(_stt, exec);
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return exec;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int GetProcessCount(string _driver)
        {
            try
            {
                if (myProcess.ContainsKey(_driver))
                {
                    return Convert.ToInt32(myProcess[_driver]); //Oo
                }
                return 0;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return -1;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool SearchFromDriver(DataGridViewCellCollection _cell
                                     , string _driver
                                     , string _ch
                                     , int _minute
                                     )
        {
            foreach (DataGridViewRow drvRows in dataGridViewDriver.Rows)
            {
                if (General.ToString(drvRows.Cells, ColumnName) == _driver)
                {
                    foreach (DataGridViewRow rchRows in dataGridViewChannel.Rows)
                    {
                        if (General.ToString(rchRows.Cells, ColumnChName) == _ch
                            &&
                             General.ToString(rchRows.Cells, ColumnIndex) == _driver
                           )
                        {
                            int maxc = General.ToInt32(drvRows.Cells, ColumnProcess);
                            int exec = GetProcessCount(_driver);
                            if (exec >= maxc) { continue; }
                            if (ReadyRecording(drvRows.Cells
                                              , rchRows.Cells
                                              , _cell
                                              , _minute
                                               ))
                            {
                                return true;
                            }
                        }
                    }
                }
            }
            Int32 uFlags = General.ToInt32(_cell, ColumnLog);
            _cell[ColumnLog.Index].Value = uFlags | LOG_IDF_DRIVER;
            if ((uFlags & LOG_IDF_DRIVER) == 0)
            {
                string log_text = "hCogpł("
                                + _driver + "[" + GetProcessCount(_driver) + "]) "
                                + General.ToString(_cell, ColumnTitle)
                                + "̘^Jnł܂..."
                                ;
                General.LogOut(0, log_text);
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool SearchFromChannel(DataGridViewCellCollection _cell
                                      , string _ch
                                      , int _minute
                                      )
        {
            DataGridViewCellCollection freeDrv = null;
            DataGridViewCellCollection freeRch = null;
            int overCount = int.MaxValue;
            foreach (DataGridViewRow rchRows in dataGridViewChannel.Rows)
            {
                if (General.ToString(rchRows.Cells, ColumnChName) == _ch)
                {
                    string strDriver = General.ToString(rchRows.Cells, ColumnIndex);
                    foreach (DataGridViewRow drvRows in dataGridViewDriver.Rows)
                    {
                        if (General.ToString(drvRows.Cells, ColumnName) == strDriver)
                        {
                            int maxc = General.ToInt32(drvRows.Cells, ColumnProcess);
                            int exec = GetProcessCount(strDriver);
                            if (exec >= maxc) { continue; }
                            if (exec > 0 && checkBoxRec.Checked)
                            {
                                if (exec < overCount)
                                {
                                    freeDrv = drvRows.Cells;
                                    freeRch = rchRows.Cells;
                                    overCount = exec;
                                }
                                continue;
                            }
                            if (ReadyRecording(drvRows.Cells
                                              , rchRows.Cells
                                              , _cell
                                              , _minute
                                               ))
                            {
                                return true;
                            }
                        }
                    }
                }
            }
            if (freeDrv != null && freeRch != null)
            {
                int maxc = General.ToInt32(freeDrv, ColumnProcess);
                int exec = GetProcessCount(General.ToString(freeDrv, ColumnIndex));
                if (exec < maxc)
                {
                    if (ReadyRecording(freeDrv
                                      , freeRch
                                      , _cell
                                      , _minute
                                       ))
                    {
                        return true;
                    }
                }
            }
            Int32 uFlags = General.ToInt32(_cell, ColumnLog);
            _cell[ColumnLog.Index].Value = uFlags | LOG_IDF_DRIVER;
            if ((uFlags & LOG_IDF_DRIVER) == 0)
            {
                string log_text = "p\ȃhCo܂ł("
                                + _ch + ") "
                                + General.ToString(_cell, ColumnTitle)
                                + "̘^Jnł܂..."
                                ;
                General.LogOut(0, log_text);
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private bool ReadyRecording( DataGridViewCellCollection _cellDrv
                                   , DataGridViewCellCollection _cellChl
                                   , DataGridViewCellCollection _cellSch
                                   , int _minute
                                   )
        {
            try
            {
                _cellSch[ColumnStatus.Index].Value = "";
                AddProcessCount(General.ToString(_cellDrv, ColumnIndex));

                DateTime schStart = General.ToDateTime(_cellSch, ColumnDate);
                int aheadSec = General.ToInt32(_cellDrv, ColumnAhead);
                schStart = schStart.AddSeconds(-aheadSec);
                schStart = schStart.AddSeconds(myAddStart);

                int shitfSec = RecordingShiftTime(schStart);
                schStart = schStart.AddSeconds(shitfSec);

                int lenSecond = (_minute * 60)
                              + aheadSec
                              - myAddStart
                              + myAddLength
                              - shitfSec;

                int lenMinute = lenSecond / 60;

                int lenAppend = 0 - shitfSec;

                string strCmd = General.ToString(_cellDrv, ColumnArgument);

                if (strCmd.Contains("{delay}"))
                {
                    lenSecond += shitfSec;
                }
                
                strCmd = ReplaceArgumentText( General.ToString(_cellDrv, ColumnArgument)
                                            , Path.GetFileName(General.ToString(_cellDrv, ColumnDriver))
                                            , General.ToString(_cellChl, ColumnTuning)
                                            , General.ToString(_cellChl, ColumnChannelID)
                                            , General.ToString(_cellChl, ColumnSID)
                                            , lenMinute.ToString()
                                            , lenSecond.ToString()
                                            , lenAppend.ToString()
                                            , General.ToString(_cellSch, ColumnUID)
                                            , SafeFileName(General.ToString(_cellSch, ColumnTitle))
                                            , General.ToString(_cellDrv, ColumnName)
                                            , General.ToDateTime(_cellSch, ColumnDate)
                                            );

                try
                {
                    RecorderMain recProc = new RecorderMain(General.ToString(_cellSch, ColumnUID)
                                                           , schStart
                                                           , textBoxRecPath.Text
                                                           , Path.GetDirectoryName(General.ToString(_cellDrv, ColumnDriver))
                                                           , strCmd
                                                           , General.ToString(_cellDrv, ColumnName)
                                                           , myPriority
                                                           );
                }
                catch (Exception exp)
                {
                    _cellSch[ColumnStatus.Index].Value = null;
                    SubProcessCount(General.ToString(_cellDrv, ColumnIndex));
                    General.OutputString(exp.StackTrace, exp.Message);
                    return false;
                }

                {
                    string log_text = General.ToString(_cellSch, ColumnTitle)
                                    + "̘^"
                                    + General.ToString(_cellDrv, ColumnName)
                                    + "ŏĂ܂"
                                    ;
                    Int32 uFlags = General.ToInt32(_cellDrv, ColumnLog);
                    if ((uFlags & LOG_IDF_LAGGED) != 0)
                    {
                        log_text += "xĂ܂BԌo ("
                                  + General.ToString(_cellSch, ColumnDate)
                                  + " < "
                                  + DateTime.Now.ToString()
                                  + ") c" + _minute.ToString() + ""
                                  ;
                    }
                    General.LogOut(2, log_text);
                }
                return true;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private int RecordingShiftTime(DateTime _date)
        {
            if (myShiftTime == 0) { return 0; }
            int shift = 0;
            int border = Math.Abs(myShiftTime);
        retry:
            try
            {
                foreach (DictionaryEntry entry in General.GetRecorderTable())
                {
                    RecorderMain otherRec = (RecorderMain)entry.Value;
                    TimeSpan span = _date - otherRec.ToDateTime();
                    if (span.TotalSeconds > -border
                        &&
                        span.TotalSeconds < border)
                    {
                        shift += myShiftTime;
                        _date = _date.AddSeconds(myShiftTime);
                        goto retry;
                    }
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return shift;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private string SafeFileName(string _file)
        {
            try
            {
                string strInv = "";
                char[] vInvalid = Path.GetInvalidFileNameChars();
                foreach (char cInv in vInvalid)
                {
                    strInv += cInv;
                }
                strInv = Strings.StrConv(strInv, VbStrConv.Wide, 0x0411);
                strInv = strInv.Replace('\\', '^');
                int index;
                for( index = 0; index < vInvalid.Length; ++index)
                {
                    _file = _file.Replace(vInvalid[index], strInv[index]);
                }
                foreach (char cInv in vInvalid)
                {
                    _file = _file.Replace(cInv, '_');
                }
                return _file;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return "_NAME_ERROR_";
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void RequestTwitterPost(string _msg)
        {
            if (textBoxTwiName.Text == "") { return; }
            if (textBoxTwiPass.Text == "") { return; }
            try
            {
                TwitterClient twiClient = new TwitterClient(textBoxTwiName.Text
                                                           , textBoxTwiPass.Text
                                                           , _msg
                                                           );
                buttonTwiPost.Enabled = false;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void CheckRequestTwitter()
        {
            if (textBoxTwiName.Text == "")
            {
                MessageBox.Show("[U[͂Ă܂I"
                               , "x"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Error
                               , MessageBoxDefaultButton.Button1
                               );
                return;
            }
            if (textBoxTwiPass.Text == "")
            {
                MessageBox.Show("pX[h͂Ă܂I"
                               , "x"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Error
                               , MessageBoxDefaultButton.Button1
                               );
                return;
            }
            RequestTwitterPost("eXgbZ[W𓊍e܂B");
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private string RemoveUIDText(string _title)
        {
            try
            {
                Regex repReg = new Regex("[A-z]*[0-9]+_[0-9]+_", RegexOptions.Singleline);
                return repReg.Replace(_title, "");
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return _title;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void RequestTwitterSchedule(DataGridViewCellCollection _cell)
        {
            if (checkBoxTwitter.Checked)
            {
                Int32 uFlags = General.ToInt32(_cell, ColumnLog);
                if ((uFlags & LOG_IDF_TWIREC) == 0
                    &&
                    (uFlags & LOG_IDF_TWILAG) == 0
                    &&
                    (uFlags & LOG_IDF_LAGGED) == 0
                    )
                {
                    _cell[ColumnLog.Index].Value = uFlags | LOG_IDF_TWIREC;
                    string strCh = General.ToString(_cell, ColumnRecChannel);
                    if (strCh[0] == '{')
                    {
                        strCh = strCh.Split('}')[1].Substring(1);
                    }
                    string msg_text = "u"
                                    + RemoveUIDText(General.ToString(_cell, ColumnTitle))
                                    + "v(" + strCh + ") ͂܂I";
                    RequestTwitterPost(msg_text);
                }
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void RequestTwitterLagged(DataGridViewCellCollection _cell)
        {
            if (checkBoxTwitter.Checked)
            {
                Int32 uFlags = General.ToInt32(_cell, ColumnLog);
                _cell[ColumnLog.Index].Value = uFlags | LOG_IDF_TWILAG;
                if ((uFlags & LOG_IDF_TWILAG) == 0)
                {
                    string strCh = General.ToString(_cell, ColumnRecChannel);
                    if (strCh[0] == '{')
                    {
                        strCh = strCh.Split('}')[1].Substring(1);
                    }
                    string msg_text = "u"
                                    + RemoveUIDText(General.ToString(_cell, ColumnTitle))
                                    + "v(" + strCh + ") ^悪xĂ܂I";
                    RequestTwitterPost(msg_text);
                }
            }
            
        }
 
    }
}