/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Collections;

namespace RecTestSchediEPG
{
    partial class iEPGForm
    {

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool iEPGStationSelect(string _station)
        {
            int idx;
            for (idx = 0; idx < comboBoxStation.Items.Count; ++idx)
            {
                if (_station == comboBoxStation.Items[idx].ToString())
                {
                    comboBoxStation.SelectedIndex = idx;
                    return UpdateStationSelect(_station);
                }
            }
            RecStationSelect(_station);
            int add = comboBoxStation.Items.Add(_station);
            comboBoxStation.SelectedIndex = add;
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool UpdateStationSelect(string _station)
        {
            int idx;
            for (idx = 0; idx < Channel.List().Count; ++idx)
            {
                if (_station == Channel.List()[idx].myiEPGStation)
                {
                    if (RecStationSelect(Channel.List()[idx].myRecStation))
                    {
                        textBoxAddStart.Text = Channel.List()[idx].myAddStart.ToString();
                        textBoxAddLength.Text = Channel.List()[idx].myAddLength.ToString();
                        return true;
                    }
                }
            }
            //RecStationSelect(_station);
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool RecStationSelect(string _station)
        {
            int idx;
            for (idx = 0; idx < comboBoxRecCh.Items.Count; ++idx)
            {
                if (_station == comboBoxRecCh.Items[idx].ToString())
                {
                    comboBoxRecCh.SelectedIndex = idx;
                    return true;
                }
            }
            ClearRecStation();
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void ShowForm()
        {
            if (!Config.GetInstance().Check())
            {
                buttonOK.Text = "XV";
            }
            else
            {
                buttonOK.Text = "M";
            }
            this.WindowState = FormWindowState.Normal;
            this.Show();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void ClearAll()
        {
            comboBoxStation.Items.Clear();
            comboBoxRecCh.Items.Clear();
            textBoxAddLength.Text = "0";
            textBoxAddStart.Text = "0";
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void ClearRecStation()
        {
            comboBoxStation.SelectedIndex = -1;
            comboBoxStation.Text = "";
            textBoxAddStart.Text = "0";
            textBoxAddLength.Text = "0";
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void RefreshChannel()
        {
            ClearAll();
            foreach (Channel ch in Channel.List())
            {
                comboBoxStation.Items.Add(ch.myRecStation);
                //comboBoxRecCh.Items.Add(ch.myRecStation);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool CheckiEPGInfo()
        {
            if (comboBoxStation.Text == "")
            {
                MessageBox.Show("ǂw肳Ă܂I"
                                , "s"
                                , MessageBoxButtons.OK
                                , MessageBoxIcon.Exclamation
                                , MessageBoxDefaultButton.Button1
                                );
                return false;
            }
            if (comboBoxRecCh.Text == "")
            {
                MessageBox.Show("^悷ǂw肳Ă܂I"
                                , "s"
                                , MessageBoxButtons.OK
                                , MessageBoxIcon.Exclamation
                                , MessageBoxDefaultButton.Button1
                                );
                return false;
            }
            if (iEPGFile.GetInstance().myTitle == "")
            {
                MessageBox.Show("^Cg̓ǂݍ݂Ɏs܂I"
                                , "s"
                                , MessageBoxButtons.OK
                                , MessageBoxIcon.Exclamation
                                , MessageBoxDefaultButton.Button1
                                );
                return false;
            }
            return true;
        }
        
    }
}